#region Copyright Syncfusion Inc. 2001 - 2007
//
//  Copyright Syncfusion Inc. 2001 - 2007. All rights reserved.
//
//  Use of this code is subject to the terms of our license.
//  A copy of the current license can be obtained at any time by e-mailing
//  licensing@syncfusion.com. Any infringement will be prosecuted under
//  applicable laws. 
//
#endregion

using System;
using System.Drawing;
using System.Collections;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Text;

using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Diagnostics;
using Syncfusion.Styles;

namespace GridSample
{
	public class Form1 : System.Windows.Forms.Form
	{
		internal Syncfusion.Windows.Forms.Grid.GridControl gridControl1;
		internal System.Windows.Forms.Button printPreviewButton;
		internal System.Windows.Forms.PropertyGrid propertyGrid1;
		internal Syncfusion.Windows.Forms.SplitterControl splitterControl1;
		internal DataSet1 dataSet11;
		internal System.Windows.Forms.Button buttonCauseValidation;
		internal System.Windows.Forms.Button buttonNoValidation;
		private System.Windows.Forms.CheckBox checkBoxMouseMessage;
		internal System.ComponentModel.Container components = null;
		private System.Windows.Forms.CheckBox checkBoxEnableTracing;
		private System.Windows.Forms.ContextMenu contextMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.Splitter splitter1;
		internal System.Windows.Forms.ListBox output;
		CurrentCellEventTracer tracer;

		public Form1()
		{
			dataSet11 = new DataSet1();

			InitializeComponent();

			this.ActiveControl = this.splitterControl1;

			splitterControl1.ThemesEnabled = true;

			gridControl1.Initialize();
			gridControl1.ThemesEnabled = true;
			gridControl1.ControllerOptions &= ~(GridControllerOptions.OleDataSource|GridControllerOptions.OleDropTarget);
			gridControl1.CurrentCell.MoveTo(1, 1);
			gridControl1.BaseStylesMap["Header"].StyleInfo.Enabled = false;
			gridControl1.VScrollPixel = true;
			gridControl1.HScrollPixel = true;


			tracer = new CurrentCellEventTracer(this.splitterControl1, this.output);
			checkBoxMouseMessage.Checked = tracer.DisplayMouseMessages;
			checkBoxEnableTracing.Checked = tracer.Enabled;

			GridStyleInfo heading1 = gridControl1.BaseStylesMap["Heading 1"].StyleInfo;
			heading1.TextColor = Color.Blue;
			heading1.Font.Size = 14;
			heading1.Font.Bold = true;

			GridStyleInfo heading2 = gridControl1.BaseStylesMap["Heading 2"].StyleInfo;
			heading2.TextColor = Color.Blue;
			heading2.Font.Size = 14;
			heading2.Font.Bold = true;

			this.output.ContextMenu = this.contextMenu1;

			this.propertyGrid1.CausesValidation = false;			
			this.splitter1.CausesValidation = false;
			this.panel1.CausesValidation = false;
			this.panel2.CausesValidation = false;

           // this.propertyGrid1.LineColor = Color.FromArgb(0xde, 0x64, 0x13);//System.Drawing.Color.Silver;

			// read the data from a local XML file
			ReadXml(this.dataSet11, @"Data\GDBDdata.XML");
		}

		//hunt the folder tree for the data\*.xml file..
		void ReadXml(DataSet ds, string xmlFileName)
		{
			if (ds == null)
				return;

			for (int n = 0; n < 10; n++)
			{
				if (System.IO.File.Exists(xmlFileName))
				{
					ds.ReadXml(xmlFileName);
					break;
				}
				xmlFileName = @"..\" + xmlFileName;
			}
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            Syncfusion.Windows.Forms.Grid.GridBaseStyle gridBaseStyle1 = new Syncfusion.Windows.Forms.Grid.GridBaseStyle();
            Syncfusion.Windows.Forms.Grid.GridBaseStyle gridBaseStyle2 = new Syncfusion.Windows.Forms.Grid.GridBaseStyle();
            Syncfusion.Windows.Forms.Grid.GridBaseStyle gridBaseStyle3 = new Syncfusion.Windows.Forms.Grid.GridBaseStyle();
            Syncfusion.Windows.Forms.Grid.GridBaseStyle gridBaseStyle4 = new Syncfusion.Windows.Forms.Grid.GridBaseStyle();
            Syncfusion.Windows.Forms.Grid.GridCellInfo gridCellInfo1 = new Syncfusion.Windows.Forms.Grid.GridCellInfo();
            this.gridControl1 = new Syncfusion.Windows.Forms.Grid.GridControl();
            this.printPreviewButton = new System.Windows.Forms.Button();
            this.propertyGrid1 = new System.Windows.Forms.PropertyGrid();
            this.splitterControl1 = new Syncfusion.Windows.Forms.SplitterControl();
            this.output = new System.Windows.Forms.ListBox();
            this.buttonCauseValidation = new System.Windows.Forms.Button();
            this.buttonNoValidation = new System.Windows.Forms.Button();
            this.checkBoxMouseMessage = new System.Windows.Forms.CheckBox();
            this.checkBoxEnableTracing = new System.Windows.Forms.CheckBox();
            this.contextMenu1 = new System.Windows.Forms.ContextMenu();
            this.menuItem1 = new System.Windows.Forms.MenuItem();
            this.panel1 = new System.Windows.Forms.Panel();
            this.panel2 = new System.Windows.Forms.Panel();
            this.splitter1 = new System.Windows.Forms.Splitter();
            ((System.ComponentModel.ISupportInitialize)(this.gridControl1)).BeginInit();
            this.splitterControl1.SuspendLayout();
            this.panel1.SuspendLayout();
            this.panel2.SuspendLayout();
            this.SuspendLayout();
            // 
            // gridControl1
            // 
            this.gridControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                        | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            gridBaseStyle1.Name = "Row Header";
            gridBaseStyle1.StyleInfo.BaseStyle = "Header";
            gridBaseStyle1.StyleInfo.HorizontalAlignment = Syncfusion.Windows.Forms.Grid.GridHorizontalAlignment.Left;
            gridBaseStyle1.StyleInfo.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.Horizontal, System.Drawing.Color.FromArgb(((int)(((byte)(203)))), ((int)(((byte)(199)))), ((int)(((byte)(184))))), System.Drawing.Color.FromArgb(((int)(((byte)(238)))), ((int)(((byte)(234)))), ((int)(((byte)(216))))));
            gridBaseStyle2.Name = "Column Header";
            gridBaseStyle2.StyleInfo.BaseStyle = "Header";
            gridBaseStyle2.StyleInfo.HorizontalAlignment = Syncfusion.Windows.Forms.Grid.GridHorizontalAlignment.Center;
            gridBaseStyle3.Name = "Standard";
            gridBaseStyle3.StyleInfo.Font.Facename = "Tahoma";
            gridBaseStyle3.StyleInfo.Interior = new Syncfusion.Drawing.BrushInfo(System.Drawing.SystemColors.Window);
            gridBaseStyle4.Name = "Header";
            gridBaseStyle4.StyleInfo.Borders.Bottom = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.None);
            gridBaseStyle4.StyleInfo.Borders.Left = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.None);
            gridBaseStyle4.StyleInfo.Borders.Right = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.None);
            gridBaseStyle4.StyleInfo.Borders.Top = new Syncfusion.Windows.Forms.Grid.GridBorder(Syncfusion.Windows.Forms.Grid.GridBorderStyle.None);
            gridBaseStyle4.StyleInfo.CellType = "Header";
            gridBaseStyle4.StyleInfo.Font.Bold = true;
            gridBaseStyle4.StyleInfo.Interior = new Syncfusion.Drawing.BrushInfo(Syncfusion.Drawing.GradientStyle.Vertical, System.Drawing.Color.FromArgb(((int)(((byte)(203)))), ((int)(((byte)(199)))), ((int)(((byte)(184))))), System.Drawing.Color.FromArgb(((int)(((byte)(238)))), ((int)(((byte)(234)))), ((int)(((byte)(216))))));
            gridBaseStyle4.StyleInfo.VerticalAlignment = Syncfusion.Windows.Forms.Grid.GridVerticalAlignment.Middle;
            this.gridControl1.BaseStylesMap.AddRange(new Syncfusion.Windows.Forms.Grid.GridBaseStyle[] {
            gridBaseStyle1,
            gridBaseStyle2,
            gridBaseStyle3,
            gridBaseStyle4});
            this.gridControl1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.gridControl1.ColCount = 12;
            this.gridControl1.ColWidthEntries.AddRange(new Syncfusion.Windows.Forms.Grid.GridColWidth[] {
            new Syncfusion.Windows.Forms.Grid.GridColWidth(0, 35)});
            this.gridControl1.DefaultGridBorderStyle = Syncfusion.Windows.Forms.Grid.GridBorderStyle.Solid;
            this.gridControl1.FillSplitterPane = true;
            this.gridControl1.Font = new System.Drawing.Font("Verdana", 8.5F);
            this.gridControl1.ForeColor = System.Drawing.Color.MidnightBlue;
            gridCellInfo1.Col = -1;
            gridCellInfo1.Row = -1;
            gridCellInfo1.StyleInfo.Font.Bold = false;
            gridCellInfo1.StyleInfo.Font.Facename = "Verdana";
            gridCellInfo1.StyleInfo.Font.Italic = false;
            gridCellInfo1.StyleInfo.Font.Size = 8.5F;
            gridCellInfo1.StyleInfo.Font.Strikeout = false;
            gridCellInfo1.StyleInfo.Font.Underline = false;
            gridCellInfo1.StyleInfo.Font.Unit = System.Drawing.GraphicsUnit.Point;
            this.gridControl1.GridCells.AddRange(new Syncfusion.Windows.Forms.Grid.GridCellInfo[] {
            gridCellInfo1});
            //this.gridControl1.GridVisualStyles = Syncfusion.Windows.Forms.GridVisualStyles.Office2007Blue;
            this.gridControl1.HorizontalThumbTrack = true;
            this.gridControl1.Location = new System.Drawing.Point(0, 0);
            this.gridControl1.Name = "gridControl1";
            this.gridControl1.Properties.BackgroundColor = System.Drawing.Color.FromArgb(((int)(((byte)(227)))), ((int)(((byte)(239)))), ((int)(((byte)(255)))));
            this.gridControl1.Properties.GridLineColor = System.Drawing.Color.FromArgb(((int)(((byte)(208)))), ((int)(((byte)(215)))), ((int)(((byte)(229)))));
            this.gridControl1.RightToLeft = System.Windows.Forms.RightToLeft.No;
            this.gridControl1.RowCount = 120;
            this.gridControl1.RowHeightEntries.AddRange(new Syncfusion.Windows.Forms.Grid.GridRowHeight[] {
            new Syncfusion.Windows.Forms.Grid.GridRowHeight(0, 21)});
            this.gridControl1.SerializeCellsBehavior = Syncfusion.Windows.Forms.Grid.GridSerializeCellsBehavior.SerializeIntoCode;
            this.gridControl1.Size = new System.Drawing.Size(505, 313);
            this.gridControl1.SmartSizeBox = false;
            this.gridControl1.ThemesEnabled = true;
            this.gridControl1.VerticalThumbTrack = true;
            this.gridControl1.SelectionChanged += new Syncfusion.Windows.Forms.Grid.GridSelectionChangedEventHandler(this.grid_SelectionChanged);
            this.gridControl1.CurrentCellMoved += new Syncfusion.Windows.Forms.Grid.GridCurrentCellMovedEventHandler(this.grid_CurrentCellMoved);
            // 
            // printPreviewButton
            // 
            this.printPreviewButton.BackColor = System.Drawing.SystemColors.Control;
            this.printPreviewButton.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.printPreviewButton.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.printPreviewButton.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
            this.printPreviewButton.Location = new System.Drawing.Point(248, 8);
            this.printPreviewButton.Name = "printPreviewButton";
            this.printPreviewButton.Size = new System.Drawing.Size(240, 23);
            this.printPreviewButton.TabIndex = 1;
            this.printPreviewButton.Text = "Print Preview";
            this.printPreviewButton.UseVisualStyleBackColor = false;
            this.printPreviewButton.Click += new System.EventHandler(this.printPreviewButton_Click);
            // 
            // propertyGrid1
            // 
            this.propertyGrid1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.propertyGrid1.LineColor = System.Drawing.SystemColors.ScrollBar;
            this.propertyGrid1.Location = new System.Drawing.Point(561, 40);
            this.propertyGrid1.Name = "propertyGrid1";
            this.propertyGrid1.Size = new System.Drawing.Size(208, 332);
            this.propertyGrid1.TabIndex = 2;
            this.propertyGrid1.ViewBackColor = System.Drawing.Color.White;
            this.propertyGrid1.ViewForeColor = System.Drawing.Color.FromArgb(((int)(((byte)(0)))), ((int)(((byte)(21)))), ((int)(((byte)(84)))));
            // 
            // splitterControl1
            // 
            this.splitterControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                        | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.splitterControl1.BackColor = System.Drawing.Color.Silver;
            this.splitterControl1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.splitterControl1.Controls.Add(this.gridControl1);
            this.splitterControl1.Location = new System.Drawing.Point(17, 40);
            this.splitterControl1.Name = "splitterControl1";
            this.splitterControl1.Size = new System.Drawing.Size(524, 332);
            this.splitterControl1.SplitBars = ((Syncfusion.Windows.Forms.DynamicSplitBars)((Syncfusion.Windows.Forms.DynamicSplitBars.SplitRows | Syncfusion.Windows.Forms.DynamicSplitBars.SplitColumns)));
            this.splitterControl1.TabIndex = 6;
            this.splitterControl1.ThemesEnabled = true;
            this.splitterControl1.PaneClosing += new Syncfusion.Windows.Forms.SplitterPaneEventHandler(this.splitterControl1_PaneClosing);
            this.splitterControl1.PaneCreated += new Syncfusion.Windows.Forms.SplitterPaneEventHandler(this.splitterControl1_PaneCreated);
            // 
            // output
            // 
            this.output.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
                        | System.Windows.Forms.AnchorStyles.Left)
                        | System.Windows.Forms.AnchorStyles.Right)));
            this.output.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
            this.output.ForeColor = System.Drawing.Color.FromArgb(((int)(((byte)(0)))), ((int)(((byte)(21)))), ((int)(((byte)(84)))));
            this.output.Location = new System.Drawing.Point(17, 24);
            this.output.Name = "output";
            this.output.ScrollAlwaysVisible = true;
            this.output.Size = new System.Drawing.Size(524, 119);
            this.output.TabIndex = 4;
            // 
            // buttonCauseValidation
            // 
            this.buttonCauseValidation.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.buttonCauseValidation.BackColor = System.Drawing.SystemColors.Control;
            this.buttonCauseValidation.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.buttonCauseValidation.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.buttonCauseValidation.Location = new System.Drawing.Point(588, 24);
            this.buttonCauseValidation.Name = "buttonCauseValidation";
            this.buttonCauseValidation.Size = new System.Drawing.Size(152, 24);
            this.buttonCauseValidation.TabIndex = 5;
            this.buttonCauseValidation.Text = "CausesValidation = true";
            this.buttonCauseValidation.UseVisualStyleBackColor = false;
            // 
            // buttonNoValidation
            // 
            this.buttonNoValidation.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.buttonNoValidation.CausesValidation = false;
            this.buttonNoValidation.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.buttonNoValidation.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.buttonNoValidation.Location = new System.Drawing.Point(588, 54);
            this.buttonNoValidation.Name = "buttonNoValidation";
            this.buttonNoValidation.Size = new System.Drawing.Size(152, 24);
            this.buttonNoValidation.TabIndex = 5;
            this.buttonNoValidation.Text = "CausesValidation = false";
            // 
            // checkBoxMouseMessage
            // 
            this.checkBoxMouseMessage.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.checkBoxMouseMessage.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.checkBoxMouseMessage.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.checkBoxMouseMessage.Location = new System.Drawing.Point(588, 117);
            this.checkBoxMouseMessage.Name = "checkBoxMouseMessage";
            this.checkBoxMouseMessage.Size = new System.Drawing.Size(168, 27);
            this.checkBoxMouseMessage.TabIndex = 7;
            this.checkBoxMouseMessage.Text = "Trace Mouse and Control Messages";
            this.checkBoxMouseMessage.CheckedChanged += new System.EventHandler(this.checkBoxMouseMessage_CheckedChanged);
            // 
            // checkBoxEnableTracing
            // 
            this.checkBoxEnableTracing.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
            this.checkBoxEnableTracing.FlatStyle = System.Windows.Forms.FlatStyle.System;
            this.checkBoxEnableTracing.Font = new System.Drawing.Font("Verdana", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte)(0)));
            this.checkBoxEnableTracing.Location = new System.Drawing.Point(588, 96);
            this.checkBoxEnableTracing.Name = "checkBoxEnableTracing";
            this.checkBoxEnableTracing.Size = new System.Drawing.Size(152, 16);
            this.checkBoxEnableTracing.TabIndex = 7;
            this.checkBoxEnableTracing.Text = "Enable Tracing";
            this.checkBoxEnableTracing.CheckedChanged += new System.EventHandler(this.checkBoxEnableTracing_CheckedChanged);
            // 
            // contextMenu1
            // 
            this.contextMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
            this.menuItem1});
            // 
            // menuItem1
            // 
            this.menuItem1.Index = 0;
            this.menuItem1.Text = "&Clear Window";
            this.menuItem1.Click += new System.EventHandler(this.menuItem1_Click);
            // 
            // panel1
            // 
            this.panel1.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(223)))), ((int)(((byte)(227)))), ((int)(((byte)(239)))));
            this.panel1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
            this.panel1.Controls.Add(this.printPreviewButton);
            this.panel1.Controls.Add(this.splitterControl1);
            this.panel1.Controls.Add(this.propertyGrid1);
            this.panel1.Dock = System.Windows.Forms.DockStyle.Top;
            this.panel1.Location = new System.Drawing.Point(0, 0);
            this.panel1.Name = "panel1";
            this.panel1.Size = new System.Drawing.Size(792, 384);
            this.panel1.TabIndex = 8;
            // 
            // panel2
            // 
            this.panel2.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(223)))), ((int)(((byte)(227)))), ((int)(((byte)(239)))));
            this.panel2.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
            this.panel2.Controls.Add(this.output);
            this.panel2.Controls.Add(this.checkBoxEnableTracing);
            this.panel2.Controls.Add(this.buttonNoValidation);
            this.panel2.Controls.Add(this.checkBoxMouseMessage);
            this.panel2.Controls.Add(this.buttonCauseValidation);
            this.panel2.Dock = System.Windows.Forms.DockStyle.Fill;
            this.panel2.Location = new System.Drawing.Point(0, 384);
            this.panel2.Name = "panel2";
            this.panel2.Size = new System.Drawing.Size(792, 182);
            this.panel2.TabIndex = 9;
            // 
            // splitter1
            // 
            this.splitter1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
            this.splitter1.Dock = System.Windows.Forms.DockStyle.Top;
            this.splitter1.Location = new System.Drawing.Point(0, 384);
            this.splitter1.Name = "splitter1";
            this.splitter1.Size = new System.Drawing.Size(792, 8);
            this.splitter1.TabIndex = 10;
            this.splitter1.TabStop = false;
            // 
            // Form1
            // 
            this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
            this.BackColor = System.Drawing.Color.FromArgb(((int)(((byte)(223)))), ((int)(((byte)(227)))), ((int)(((byte)(239)))));
            this.ClientSize = new System.Drawing.Size(792, 566);
            this.Controls.Add(this.splitter1);
            this.Controls.Add(this.panel2);
            this.Controls.Add(this.panel1);
            this.Name = "Form1";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "CalendarCells...";
            this.Load += new System.EventHandler(this.Form1_Load);
            ((System.ComponentModel.ISupportInitialize)(this.gridControl1)).EndInit();
            this.splitterControl1.ResumeLayout(false);
            this.panel1.ResumeLayout(false);
            this.panel2.ResumeLayout(false);
            this.ResumeLayout(false);

		}
#endregion


		private void Form1_Load(object sender, System.EventArgs e)
		{
			System.Drawing.Icon ico = new System.Drawing.Icon(Syncfusion.Windows.Forms.WinFormsUtils.FindFile("Icon", "sfgrid.ico"));
			this.Icon = ico ;			
			this.gridControl1.DefaultRowHeight = 18;
			this.gridControl1.DefaultColWidth = 70;			
			
		//	this.gridControl1.DefaultGridBorderStyle = GridBorderStyle.Solid;	
			
		}

		private void printPreviewButton_Click(object sender, System.EventArgs e)
		{
			if (gridControl1 != null)
			{
				try 
				{
					GridControl grid = this.splitterControl1.ActivePane as GridControl;
					if (grid != null)
					{
						GridPrintDocument pd = new GridPrintDocument(gridControl1, true); //Assumes the default printer

						PrintPreviewDialog dlg = new PrintPreviewDialog() ;
						dlg.Document = pd;
						dlg.ShowDialog();
					}
				} 
				catch(Exception ex) 
				{ 
					MessageBox.Show("An error occurred attempting to preview the file to print - " + ex.Message);
				}
			}

		}

		private void checkBoxMouseMessage_CheckedChanged(object sender, System.EventArgs e)
		{
			tracer.DisplayMouseMessages = checkBoxMouseMessage.Checked;
		}

		private void checkBoxEnableTracing_CheckedChanged(object sender, System.EventArgs e)
		{
			tracer.Enabled = this.checkBoxEnableTracing.Checked;
		}

		private void menuItem1_Click(object sender, System.EventArgs e)
		{
			this.output.Items.Clear();
		}

		private void splitterControl1_PaneClosing(object sender, Syncfusion.Windows.Forms.SplitterPaneEventArgs e)
		{
			GridControl grid = (GridControl) e.Control;
			grid.CurrentCellMoved -= new Syncfusion.Windows.Forms.Grid.GridCurrentCellMovedEventHandler(this.grid_CurrentCellMoved);
			grid.SelectionChanged -= new GridSelectionChangedEventHandler(grid_SelectionChanged);
		}

		private void splitterControl1_PaneCreated(object sender, Syncfusion.Windows.Forms.SplitterPaneEventArgs e)
		{
			GridControl grid = (GridControl) e.Control;
			grid.CurrentCellMoved += new Syncfusion.Windows.Forms.Grid.GridCurrentCellMovedEventHandler(this.grid_CurrentCellMoved);
			grid.SelectionChanged += new GridSelectionChangedEventHandler(grid_SelectionChanged);
		}

		private void grid_CurrentCellMoved(object sender, Syncfusion.Windows.Forms.Grid.GridCurrentCellMovedEventArgs e)
		{
			grid = (GridControlBase) sender;
			DelayRefreshPropertyGrid(GridRangeInfo.Cell(grid.CurrentCell.RowIndex, grid.CurrentCell.ColIndex), 50);
		}

		private void grid_SelectionChanged(object sender, GridSelectionChangedEventArgs e)
		{
			DelayRefreshPropertyGrid(e.Range, 200);
		}

		private GridRangeInfo range = GridRangeInfo.Empty;
		private GridStyleInfo style = null;
		private GridControlBase grid = null;
		bool refreshPropertyGridNextIdle = false;
		Timer refreshTimer = null;

		private void DelayRefreshPropertyGrid(GridRangeInfo range, int interval)
		{
			if (refreshTimer != null)
			{
				refreshPropertyGridNextIdle = false;
				refreshTimer.Stop();
			}
			else
			{
				refreshTimer = new Timer();
				refreshTimer.Interval = interval;
				refreshTimer.Tick += new EventHandler(DelayedRefreshPropertyGrid);
			}
			refreshTimer.Start();
			refreshPropertyGridNextIdle = true;
			this.range = range;
		}

		void DelayedRefreshPropertyGrid(object sender, EventArgs e)
		{
			TraceUtil.TraceCurrentMethodInfo();
			Timer t = sender as Timer;
			t.Dispose();
			this.refreshTimer = null;

			if (refreshPropertyGridNextIdle)
				RefreshPropertyGrid();
		}

		public void RefreshPropertyGrid()
		{
			{
				refreshPropertyGridNextIdle = false;
				if (style != null)
				{
					style.Changed -= new StyleChangedEventHandler(GridStyleInfoChanged);
				}
				
				grid = (GridControlBase) splitterControl1.ActivePane;
				style = grid.Model.GetCombinedStyle(range);
				if (style != null)
				{
					propertyGrid1.SelectedObject = style;
					style.Changed += new StyleChangedEventHandler(GridStyleInfoChanged);
				}
				else
					range = GridRangeInfo.Empty;
			}
		}

		public void ShowPropertyGridItem(string category, string label)
		{
			RefreshPropertyGrid(); 
			GridItem gi = propertyGrid1.SelectedGridItem;
			while (gi != null && gi.GridItemType != GridItemType.Root)
				gi = gi.Parent;

			if (gi != null)
			{
				// Categories
				GridItemCollection categories = gi.GridItems;
				GridItem sliderCategory = categories[category];
				if (sliderCategory != null)
				{
					GridItemCollection items = sliderCategory.GridItems;
					GridItem item;
					if (label == "")
						item = items[Math.Min(10, items.Count-1)];
					else
						item = items[label];
					item.Select();
					if (item.Expandable)
					{
						propertyGrid1.ExpandAllGridItems();
						items = item.GridItems;
						items[Math.Min(10, items.Count-1)].Select();
					}
				}
			}
			RefreshPropertyGrid(); 
		}

		void GridStyleInfoChanged(object sender, StyleChangedEventArgs e)
		{
			if (!refreshPropertyGridNextIdle && !range.IsEmpty && grid != null && style != null)
			{
				grid.Model.ChangeCells(range, style, StyleModifyType.Changes);
			}
		}
	}
}
